 SUBROUTINE data_log( array, i1, i2, j1, j2, k1, k2 )

!--------------------------------------------------------------------------------!
! This file is part of PALM.
!
! PALM is free software: you can redistribute it and/or modify it under the terms
! of the GNU General Public License as published by the Free Software Foundation,
! either version 3 of the License, or (at your option) any later version.
!
! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with
! PALM. If not, see <http://www.gnu.org/licenses/>.
!
! Copyright 1997-2014 Leibniz Universitaet Hannover
!--------------------------------------------------------------------------------!
!
! Current revisions:
! -----------------
! 
!
! Former revisions:
! -----------------
! $Id: data_log.f90 1310 2014-03-14 08:01:56Z raasch $
!
! 1036 2012-10-22 13:43:42Z raasch
! code put under GPL (PALM 3.9)
!
! RCS Log replace by Id keyword, revision history cleaned up
!
! Revision 1.1  2006/02/23 10:09:29  raasch
! Initial revision
!
!
! Description:
! ------------
! Complete logging of data
!------------------------------------------------------------------------------!
#if defined( __logging )

    USE control_parameters
    USE pegrid

    IMPLICIT NONE

    INTEGER ::  i1, i2, j1, j2, k1, k2

    REAL, DIMENSION(i1:i2,j1:j2,k1:k2) ::  array


!
!-- Open the file for data logging
    CALL check_open( 20 )

!
!-- Write the message string
    WRITE ( 20 )  log_message

!
!-- Write the simulated time and the array indices
    WRITE ( 20 )  simulated_time, i1, i2, j1, j2, k1, k2

!
!-- Write the array
    WRITE ( 20 )  array

#endif
 END SUBROUTINE data_log



 SUBROUTINE data_log_2d( array, i1, i2, j1, j2)

!------------------------------------------------------------------------------!
! Description:
! ------------
! Same as above, for 2d arrays
!------------------------------------------------------------------------------!
#if defined( __logging )

    USE control_parameters
    USE pegrid

    IMPLICIT NONE

    INTEGER ::  i1, i2, j1, j2

    REAL, DIMENSION(i1:i2,j1:j2) ::  array


!
!-- Open the file for data logging
    CALL check_open( 20 )

!
!-- Write the message string
    WRITE ( 20 )  log_message

!
!-- Write the simulated time and the array indices
    WRITE ( 20 )  simulated_time, i1, i2, j1, j2

!
!-- Write the array
    WRITE ( 20 )  array

#endif
 END SUBROUTINE data_log_2d



 SUBROUTINE data_log_2d_int( array, i1, i2, j1, j2)

!------------------------------------------------------------------------------!
! Description:
! ------------
! Same as above, for 2d integer arrays
!------------------------------------------------------------------------------!
#if defined( __logging )

    USE control_parameters
    USE pegrid

    IMPLICIT NONE

    INTEGER ::  i1, i2, j1, j2

    INTEGER, DIMENSION(i1:i2,j1:j2) ::  array


!
!-- Open the file for data logging
    CALL check_open( 20 )

!
!-- Write the message string
    WRITE ( 20 )  log_message

!
!-- Write the simulated time and the array indices
    WRITE ( 20 )  simulated_time, i1, i2, j1, j2

!
!-- Write the array
    WRITE ( 20 )  array

#endif
 END SUBROUTINE data_log_2d_int
