 SUBROUTINE local_getenv( var, ivar, value, ivalue )

!--------------------------------------------------------------------------------!
! This file is part of PALM.
!
! PALM is free software: you can redistribute it and/or modify it under the terms
! of the GNU General Public License as published by the Free Software Foundation,
! either version 3 of the License, or (at your option) any later version.
!
! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with
! PALM. If not, see <http://www.gnu.org/licenses/>.
!
! Copyright 1997-2014 Leibniz Universitaet Hannover
!--------------------------------------------------------------------------------!
!
! Current revisions:
! -----------------
! 
!
! Former revisions:
! -----------------
! $Id: local_getenv.f90 1310 2014-03-14 08:01:56Z raasch $
!
! 1036 2012-10-22 13:43:42Z raasch
! code put under GPL (PALM 3.9)
!
! 82 2007-04-16 15:40:52Z raasch
! Preprocessor directives for old systems removed
!
! RCS Log replace by Id keyword, revision history cleaned up
!
! Revision 1.5  2003/05/09 14:37:07  raasch
! On the MUK cluster, only PE0 is able to read environment variables.
! Therefore, they have to be communicated via broadcast to the other PEs.
!
! Revision 1.1  1997/08/11 06:21:01  raasch
! Initial revision
!
!
! Description:
! ------------
! Getting the values of environment-variabls (for different operating-systems)
!------------------------------------------------------------------------------!

#if defined( __lcmuk )
    USE pegrid
#endif
    CHARACTER (LEN=*) ::  var, value
    INTEGER           ::  ivalue, ivar
#if defined( __lcmuk )
    INTEGER            ::  i, ia(20)
#endif

    CALL GETENV( var(1:ivar), value )
    ivalue = LEN_TRIM( value )

#if defined( __lcmuk )  &&  defined( __parallel )
    ia = IACHAR( ' ' )
    IF ( myid == 0 )  THEN
       DO  i = 1, ivalue
          ia(i) = IACHAR( value(i:i) )
       ENDDO
    ENDIF
    CALL MPI_BCAST( ia(1), 20, MPI_INTEGER, 0, comm2d, ierr )
    DO  i = 1, 20
       IF ( ACHAR( ia(i) ) /= ' ' )  value(i:i) = ACHAR( ia(i) )
    ENDDO
    ivalue = LEN_TRIM( value )
#endif
 END SUBROUTINE local_getenv    
