 SUBROUTINE user_data_output_mask( av, variable, found, local_pf )

!--------------------------------------------------------------------------------!
! This file is part of PALM.
!
! PALM is free software: you can redistribute it and/or modify it under the terms
! of the GNU General Public License as published by the Free Software Foundation,
! either version 3 of the License, or (at your option) any later version.
!
! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with
! PALM. If not, see <http://www.gnu.org/licenses/>.
!
! Copyright 1997-2014 Leibniz Universitaet Hannover
!--------------------------------------------------------------------------------!
!
! Current revisions:
! ------------------
! 
!
! Former revisions:
! -----------------
! $Id: user_data_output_mask.f90 1310 2014-03-14 08:01:56Z raasch $
!
! 1036 2012-10-22 13:43:42Z raasch
! code put under GPL (PALM 3.9)
!
! Initial version
!
! Description:
! ------------
! Resorts the user-defined output quantity with indices (k,j,i) to a
! temporary array with indices (i,j,k) for masked data output.
!------------------------------------------------------------------------------!

    USE control_parameters
    USE indices
    USE user

    IMPLICIT NONE

    CHARACTER (LEN=*) ::  variable

    INTEGER ::  av, i, j, k

    LOGICAL ::  found

    REAL, DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2), &
                    mask_size_l(mid,3)) ::  local_pf


    found = .TRUE.

    SELECT CASE ( TRIM( variable ) )

!
!--    Uncomment and extend the following lines, if necessary.
!--    The arrays for storing the user defined quantities (here u2 and u2_av)
!--    have to be declared and defined by the user!
!--    Sample for user-defined output:
!       CASE ( 'u2' )
!          IF ( av == 0 )  THEN
!            DO  i = 1, mask_size_l(mid,1)
!               DO  j = 1, mask_size_l(mid,2)
!                  DO  k = 1, mask_size_l(mid,3)
!                      local_pf(i,j,k) = u2(mask_k(mid,k), &
!                                           mask_j(mid,j),mask_i(mid,i))
!                   ENDDO
!                ENDDO
!             ENDDO
!          ELSE
!            DO  i = 1, mask_size_l(mid,1)
!               DO  j = 1, mask_size_l(mid,2)
!                  DO  k = 1, mask_size_l(mid,3)
!                      local_pf(i,j,k) = u2_av(mask_k(mid,k), &
!                                              mask_j(mid,j),mask_i(mid,i))
!                   ENDDO
!                ENDDO
!             ENDDO
!          ENDIF
!

       CASE DEFAULT
          found = .FALSE.

    END SELECT


 END SUBROUTINE user_data_output_mask
